/***************************************************************************
                          fenster.cpp  -  description
                             -------------------
    begin                : Do Jan 29 2004
    copyright            : (C) 2004 by Sommer Niko
    email                : stealth20@rin.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "fenster.h"
#include "prefer.h"
#include <kmessagebox.h>
#include <klocale.h>
#include <qvariant.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>




int breite = 70;

myview::myview( KConfig* ksCfg,  QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
  if ( !name )
    setName( "myview" );


  setMinimumSize( QSize( breite*20, breite*20 ) );
  languageChange();
  clearWState( WState_Polished );
  /////////////////////////////////

  ksConfig = ksCfg;
  
  ksConfig->setGroup("General");
  update = ksConfig->readNumEntry("rtime", 1000);
  
  myTimer = startTimer(update);
  
  l = 15;
  m = 70; 

  parse_file(&previous, new QString(ksConfig->readEntry("interface","dsl0")));

}

myview::~myview()
{
  
}

void myview::languageChange()
{
  setCaption( tr2i18n( "F" ) );
}

void myview::timerEvent(QTimerEvent * te)
{

  if(te->timerId() == myTimer)
  {
    monitor_interface(&bw);

    ksConfig->setGroup("Limits");
    up_max   = ksConfig->readNumEntry("up",20);
    down_max = ksConfig->readNumEntry("down",90);
      
      if(breite)
      {
        l =  (bw.outgoing)/(up_max/( (breite)/3) );
        m =  (bw.incoming)/(down_max/( (breite)/3) );
      }

    repaint(true);

  }
  
  ksConfig->setGroup("General");
  if(update != ksConfig->readNumEntry("rtime", 1000))
  {
    update = ksConfig->readNumEntry("rtime", 1000);
    killTimers();
    myTimer = startTimer(update);
  }

}
   

void myview::paintEvent(QPaintEvent * pe)
{

  QString temp("");
  QPainter p(this) ;

  p.begin(this);

  ////////////////////////////////
  
  ksConfig->setGroup("Colors");
  
  QRect r (20, 20, 5, 55);        

/////////////////////////////////  
  p.setPen (QPen (ksConfig->readColorEntry("normal", new QColor(darkGreen))));
  p.setBrush (darkGreen);
  for( int i = 0; i < m ;i++)
  {
    if (i >= breite/3 * 0.7)
    {
      p.setPen(QPen (ksConfig->readColorEntry("warning", new QColor(red))));
    }

    r.setRect(i * 3,(int) (breite / 4 - breite/4*0.7), 2, (int)(breite/2*0.7));
    p.drawRect (r);
  }
  p.setPen (QPen (ksConfig->readColorEntry("normal_up", new QColor(darkGreen))));
  for( int i = 0; i < l ;i++)
  {
    if (i >= breite /3 * 0.7)
    {
      p.setPen(QPen (ksConfig->readColorEntry("warning_up", new QColor(red))));
    }

    r.setRect(i * 3, (int)((breite*3/4) - (breite/4*0.7)), 2, (int)(breite/2*0.7) );
    p.drawRect (r);
  }
  
  p.setPen (QPen (ksConfig->readColorEntry("text", new QColor(black))));


  ksConfig->setGroup("General");  
  
  if(ksConfig->readBoolEntry("Text",true))
  {
    temp.setNum(bw.incoming);
    p.drawText (2,            1 , (int) breite, breite/2, AlignVCenter|AlignCenter, temp.ascii());

    temp.setNum(bw.outgoing);
    p.drawText (2, breite/2 + 1 , (int) breite, breite/2, AlignVCenter|AlignCenter, temp.ascii());
  }
  ////////////////////////////////
  
  if(ksConfig->readBoolEntry("Rahmen",true))
  {
    ksConfig->setGroup("Colors");
    p.setPen(QPen(ksConfig->readColorEntry("rahmen", new QColor(black))));
    //Rahmen zeichnen
    p.drawLine(0,0,breite - 1,0);    //oben
    p.drawLine(0,breite - 1,breite - 1,breite - 1);  //unten
    p.drawLine(0,0,0,breite - 1);    //links
    p.drawLine(breite - 1,0,breite -1, breite - 1);
  }
  p.end();
}

void myview::parse_file(struct bandwidth* stat, QString* c_interface )
{
    int b;
    
    QFile nsf(QString("/proc/net/dev"));
    
    if(!nsf.open(IO_ReadOnly | IO_Translate))
     fprintf(stderr,"unable to open /proc/net/dev\n");
    
    QTextStream in (&nsf);
    QString dev_file =  in.read();
    
    int pos = dev_file.find(*c_interface);
    
    QString rest = dev_file.mid(pos + c_interface->length() + 1);
    QTextIStream istr(&rest);
    istr >> stat->incoming >> b >> b >> b >> b >> b >> b >> b >> stat->outgoing;
 
    nsf.close(); 
}


void myview::monitor_interface(struct bandwidth* b)
{
  ksConfig->setGroup("Limits");
  divisor = ksConfig->readNumEntry("divisor", 1024);
     
  ksConfig->setGroup("General");
  parse_file(&aktuell, new QString(ksConfig->readEntry("interface","dsl0")));

  b->incoming = ((aktuell.incoming - previous.incoming)  / (update / 1000)) / divisor;
  b->outgoing = ((aktuell.outgoing - previous.outgoing)  / (update / 1000)) / divisor;
 
  memcpy(&previous, &aktuell,sizeof(struct bandwidth));  //save current data

}

