/***************************************************************************
 *   Copyright (C) 2004 by Sommer Niko                                     *
 *   sommer_niko@web.de                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <kglobal.h>
#include <klocale.h>
#include <kconfig.h>
#include <kapplication.h>
#include <kmessagebox.h>

#include "kbandwidth.h"

extern int breite;

kbandwidth::kbandwidth(const QString& configFile, Type type, int actions, QWidget *parent, const char *name)
    : KPanelApplet(configFile, type, actions, parent, name)
{
  // Get the current application configuration handle
  
  ksConfig = new KConfig(QString(getenv("HOME")) += "/.kbandwidth");
  //ksConfig->setGroup("General");
  myview* w = new myview(ksConfig,this);

  mainView = w;
  mainView->show();
  
  createMenu(this);

}


kbandwidth::~kbandwidth()
{}

void kbandwidth::mousePressEvent( QMouseEvent* event ){
	if( event->button() == RightButton)
		contMenu->exec( QCursor::pos() );
	else if ( event->button() == LeftButton)
	{
 		contMenu->exec( QCursor::pos() );
	}
}

void kbandwidth::createMenu(QWidget * parent)
{
   settingAction = new QAction(i18n("Settings"),0,parent);
   connect(settingAction, SIGNAL(activated()),parent,SLOT(preferences()));
   aboutAction = new QAction(i18n("About"),0,parent);
   connect(aboutAction, SIGNAL(activated()),parent,SLOT(about()));
   contMenu = new KPopupMenu("kbandwidth");
   settingAction -> addTo(contMenu);
   aboutAction   -> addTo(contMenu);
}


void kbandwidth::about()
{

  QString* mess = new QString(i18n("kbandwidth applet\nwritten by Niko Sommer.\nVersion "));
  *mess += VER;
  
  
  KMessageBox::information(0, *mess);
}


void kbandwidth::help()
{
  KMessageBox::information(0, i18n("Coming soon..."));
}


void kbandwidth::preferences()
{
  EinstellungenDialog *db = new EinstellungenDialog(ksConfig);
  db->exec();
  delete db;
}

int kbandwidth::widthForHeight(int height) const
{

  breite = height;
  return height;
}

int kbandwidth::heightForWidth(int width) const
{
  breite = width;
  return width;
}

void kbandwidth::resizeEvent(QResizeEvent *e)
{
  QFont f = font();

  if (height() > 100)
    f.setPixelSize(21);

  else if (height() > 80)
    f.setPixelSize(18);

  else if (height() > 60)
    f.setPixelSize(15);

  else if (height() > 50)
    f.setPixelSize(12);

  else
    f.setPixelSize(10);

  setFont(f);
}


extern "C"
{
  KPanelApplet* init( QWidget *parent, const QString configFile)
  {
    KGlobal::locale()->insertCatalogue("kbandwidth");
    return new kbandwidth(configFile, KPanelApplet::Normal,
                          KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
                          parent, "kbandwidth");
  }
}
