/***************************************************************************
 *   Copyright (C) 2004 by Sommer Niko                                     *
 *   sommer_niko@web.de                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KBANDWIDTH_H
#define KBANDWIDTH_H

////////////////////////////////////////////////////////
#define VER "1.0.4"
////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kpanelapplet.h>
#include <qstring.h>
#include <qfont.h>
#include <kconfig.h>
#include <qlcdnumber.h>

#include <kpopupmenu.h>
#include <qcursor.h>
#include <qaction.h>


#include "fenster.h"
#include "prefer.h"

class kbandwidth : public KPanelApplet
{
    Q_OBJECT
    
public:
    
    kbandwidth(const QString& configFile, Type t = Normal, int actions = 0,
        QWidget *parent = 0, const char *name = 0);
    
    
    ~kbandwidth();
    
    virtual int widthForHeight(int height) const;
    virtual int heightForWidth(int width) const;
    virtual void help();

public slots:
    virtual void preferences();
    virtual void about();
    
protected:
    
    virtual void mousePressEvent ( QMouseEvent*);
//    virtual void contextMenuEvent( QContextMenuEvent * );

    QAction* settingAction;
    QAction* aboutAction;
    QPopupMenu* contMenu;

    void createMenu(QWidget *);
    void resizeEvent(QResizeEvent *);

public:

    KConfig *ksConfig;
    QWidget *mainView;
};

#endif
