/***************************************************************************
                          prefer.cpp  -  description
                             -------------------
    begin                : Sa Jan 31 2004
    copyright            : (C) 2004 by Sommer Niko
    email                : stealth20@rin.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 #include "prefer.h"

  
 EinstellungenDialog::EinstellungenDialog(KConfig* ksConfig )
 {
   kConfig = ksConfig;
//////////////////   
   ksConfig->setGroup("General");
   QString *qs =new QString(ksConfig->readEntry("interface","dsl0")); 
   interface_edit ->setText(*qs);
   checkBox1      ->setChecked(ksConfig->readBoolEntry("Rahmen",true));
   TextCheckBox   ->setChecked(ksConfig->readBoolEntry("Text",true));
   timespin       ->setValue(ksConfig->readNumEntry("rtime",1000));
//////////////////   
   ksConfig->setGroup("Colors");
   WarnungButton   ->setColor(ksConfig->readColorEntry("warning", new QColor(red)));
   NormalButton    ->setColor(ksConfig->readColorEntry("normal",  new QColor(darkGreen)));
   TextColorButton ->setColor(ksConfig->readColorEntry("text",    new QColor(black)));
   RahmenButton    ->setColor(ksConfig->readColorEntry("rahmen",  new QColor(black)));
   
   WarnungButton_2   ->setColor(ksConfig->readColorEntry("warning_up", new QColor(red)));
   NormalButton_2    ->setColor(ksConfig->readColorEntry("normal_up",  new QColor(darkGreen)));
   
//////////////////   
   ksConfig->setGroup("Limits");
   downspin->setValue(ksConfig->readNumEntry("down",90));
   upspin  ->setValue(ksConfig->readNumEntry("up",20));
   switch(ksConfig->readNumEntry("divisor",1024))
   {
     case 1024:
        KB      ->setChecked(true);
     break;
     
     case 1048576:
        MB      ->setChecked(true);
     break;
     
     case 128:
        KBit    ->setChecked(true);
     break;
     
     case 131072:
        MBit    ->setChecked(true);
     break;
   }  
 }
 
void EinstellungenDialog::OkSlot(void)
 {
   save_config();
   reject();
 }
 
void EinstellungenDialog::save_config(void)
 {
//////////////////
   kConfig->setGroup("General");
   kConfig->writeEntry("interface", interface_edit->text());
   kConfig->writeEntry("Rahmen", checkBox1->isChecked());
   kConfig->writeEntry("Text", TextCheckBox->isChecked());
   kConfig->writeEntry("rtime", timespin->value());
   
//////////////////
   kConfig->setGroup("Colors");
   kConfig->writeEntry("warning", WarnungButton->color());
   kConfig->writeEntry("normal", NormalButton->color());
   kConfig->writeEntry("text", TextColorButton->color());
   kConfig->writeEntry("rahmen",  RahmenButton->color());
   
   kConfig->writeEntry("warning_up", WarnungButton_2->color());
   kConfig->writeEntry("normal_up", NormalButton_2->color());
   
//////////////////   
   kConfig->setGroup("Limits");
   kConfig->writeEntry("down", downspin->value());
   kConfig->writeEntry("up",    upspin ->value());
   
   if(  KB->isChecked())
   kConfig->writeEntry("divisor",1024);
   
   if(  MB->isChecked())
   kConfig->writeEntry("divisor",1048576);
   
   if(  KBit->isChecked())
   kConfig->writeEntry("divisor", 128);
   
   if(  MBit->isChecked())
   kConfig->writeEntry("divisor",131072);
   
   
   kConfig->sync();
 }
 
 
 EinstellungenDialog::~EinstellungenDialog()
 {
 }
